Package owl.translations.ldba2dpa

## Class AbstractBuilder<S,T,A,L,B extends GeneralizedBuchiAcceptance>

- java.lang.Object
- - owl.translations.ldba2dpa.AbstractBuilder<S,T,A,L,B>

-     public class AbstractBuilder<S,T,A,L,B extends GeneralizedBuchiAcceptance>
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Predicate<? super S>` | `isAcceptingState` |
    `protected LanguageLattice<T,A,L>` | `lattice` |
    `protected LimitDeterministicAutomaton<S,T,B,A>` | `ldba` |
    `protected List<A>` | `safetyComponents` |
    `protected List<A>` | `sortingOrder` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AbstractBuilder​(LimitDeterministicAutomaton<S,T,B,A> ldba, LanguageLattice<T,A,L> lattice, Predicate<? super S> isAcceptingState, boolean resetAfterSccSwitch)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected T` | `findNextSafety​(List<T> availableJumps, int i)` |
    `protected boolean` | `insertableToRanking​(T state, Map<A,Language<L>> existingLanguages)` |
    `static <S extends AnnotatedState<?>,A extends OmegaAcceptance> Automaton<S,A>` | `optimizeInitialState​(Automaton<S,A> readOnly)` |
    `protected boolean` | `sccSwitchOccurred​(S state, S successor)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### isAcceptingState

          protected final Predicate<? super S> isAcceptingState

    - #### lattice

          protected final LanguageLattice<T,A,L> lattice

    - #### ldba

          protected final LimitDeterministicAutomaton<S,T,B extends GeneralizedBuchiAcceptance,A> ldba

    - #### safetyComponents

          protected final List<A> safetyComponents

    - #### sortingOrder

          protected final List<A> sortingOrder

  - ### Constructor Detail

    - #### AbstractBuilder

          protected AbstractBuilder​(LimitDeterministicAutomaton<S,T,B,A> ldba,
                                    LanguageLattice<T,A,L> lattice,
                                    Predicate<? super S> isAcceptingState,
                                    boolean resetAfterSccSwitch)

  - ### Method Detail

    - #### optimizeInitialState

          public static <S extends AnnotatedState<?>,A extends OmegaAcceptance> Automaton<S,A> optimizeInitialState​(Automaton<S,A> readOnly)

    - #### findNextSafety

          @Nullable
          protected T findNextSafety​(List<T> availableJumps,
                                     int i)

    - #### insertableToRanking

          protected boolean insertableToRanking​(T state,
                                                Map<A,Language<L>> existingLanguages)

    - #### sccSwitchOccurred

          protected boolean sccSwitchOccurred​(S state,
                                              S successor)